/**************************************************************************************************
  LED.c
  Support for the yellow and red LEDs of the MINI-M4 for STM32 board.
  The yellow LED is wired to PC12.
  The red LED is wired to PC13.
**************************************************************************************************/

// Include Files
#include "LED.h"
#include "Buffers.h"



// LED connections
sbit LED_Y at GPIOC_ODR.B12;  // For the yellow LED
sbit LED_R at GPIOC_ODR.B13;  // For the red LED



// Variables



/**************************************************************************************************
  LED_Initialize */
void LED_Initialize(void) {
     GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_12 | _GPIO_PINMASK_13);  // Make port outputs
}

/**************************************************************************************************
  LED_Set_Yellow */
void LED_Set_Yellow(void) {
     LED_Y = 1;
}

/**************************************************************************************************
  LED_Clear_Yellow */
void LED_Clr_Yellow(void) {
     LED_Y = 0;
}

/**************************************************************************************************
  LED_Set_Red */
void LED_Set_Red(void) {
     LED_R = 1;
}

/**************************************************************************************************
  LED_Clear_Red */
void LED_Clr_Red(void) {
     LED_R = 0;
}

