#line 1 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
#line 1 "c:/arm projects/mini-m4 for stm32/servoproj/usb_driver.h"
#line 11 "c:/arm projects/mini-m4 for stm32/servoproj/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 64 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mini-m4 for stm32/servoproj/buffers.h"
#line 13 "c:/arm projects/mini-m4 for stm32/servoproj/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
#line 9 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mini-m4 for stm32/servoproj/timers.h"
void irqhandler_timer(void);





void Timer6_Initialize(void);
void Timer7_Initialize(void);

void Timer3_Initialize(void);
int IncPan(unsigned int Step);
int DecPan(unsigned int Step);
int HomePan(void);
int SetPan(int Value);

int IncTilt(unsigned int Step);
int DecTilt(unsigned int Step);
int HomeTilt(void);
int SetTilt(int Value);
#line 12 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
char readbuff[64];
char writebuff[64];

USB_TxStruct USB_Queue;

extern unsigned int PanVal;
extern unsigned int TiltVal;
#line 23 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
 USB_Interrupt_Proc();
}
#line 29 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USB_Init(void) {



 HID_Enable(&readbuff,&writebuff);
 USB_TxQueueInit();

}
#line 40 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USB_TxQueueInit(void) {
 USB_Queue.in = 0;
 USB_Queue.out = 0;
}
#line 48 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USB_PutQueue(char *msg) {
 USB_Queue.q[USB_Queue.in++] = msg;
 if (USB_Queue.in > ( 64 -1))
 USB_Queue.in = 0;
}
#line 60 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USB_CheckOut(void) {


 if (USB_Queue.in != USB_Queue.out) {

 if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
 USB_Queue.out++;
 if (USB_Queue.out > ( 64 -1))
 USB_Queue.out = 0;
 }
 }
}
#line 77 "C:/ARM Projects/MINI-M4 for STM32/ServoProj/USB_Driver.c"
void USB_CheckIn(void) {
 char *BufNum;
 char BuffA[8];
 char BuffB[8];
 int NumberA;
 int NumberB;
 int i,j;
 char In;

 if (HID_Read() != 0) {
 switch (readbuff[0]) {

 case 'a':
 BufNum = GetBuffer();
 sprintf(BufNum,"Command a received\r\n");
 USB_PutQueue(BufNum);
 break;
 case 'b':
 BufNum = GetBuffer();
 sprintf(BufNum,"TIM3_PSC: %04X  TIM3_ARR: %04X\r\n",TIM3_PSC,TIM3_ARR);
 USB_PutQueue(BufNum);
 break;
 case 'c':
 IncPan(28);
 BufNum = GetBuffer();
 sprintf(BufNum,"PanVal: %d\r\n",PanVal);
 USB_PutQueue(BufNum);
 break;
 case 'd':
 DecPan(28);
 BufNum = GetBuffer();
 sprintf(BufNum,"PanVal: %d\r\n",PanVal);
 USB_PutQueue(BufNum);
 break;
 case 'e':
 HomePan();
 BufNum = GetBuffer();
 sprintf(BufNum,"PanVal: %d\r\n",PanVal);
 USB_PutQueue(BufNum);
 break;
 case 'f':
 IncTilt(28);
 BufNum = GetBuffer();
 sprintf(BufNum,"TiltVal: %d\r\n",TiltVal);
 USB_PutQueue(BufNum);
 break;
 case 'g':
 DecTilt(28);
 BufNum = GetBuffer();
 sprintf(BufNum,"TiltVal: %d\r\n",TiltVal);
 USB_PutQueue(BufNum);
 break;
 case 'h':
 HomeTilt();
 BufNum = GetBuffer();
 sprintf(BufNum,"TiltVal: %d\r\n",TiltVal);
 USB_PutQueue(BufNum);
 break;
 case 'i':
 break;
 case 'j':
 break;
 case 'k':
 break;
 case 'l':
 break;
 case 'm':
 i = 0;
 j = 1;
 memset(BuffA,0,8);
 do {
 In = BuffA[i++] = readbuff[j++];

 } while (In != ' ');
 NumberA = atoi(BuffA);

 i = 0;
 memset(BuffB,0,8);
 do {
 In = BuffB[i++] = readbuff[j++];

 } while (In != ' ');
 NumberB = atoi(BuffB);


 NumberA = NumberA * 28 + 3600;
 SetPan(NumberA);

 NumberB = NumberB * 28 + 3600;
 SetTilt(NumberB);

 BufNum = GetBuffer();
 sprintf(BufNum,"%d %d\r\n",NumberA,NumberB);
 USB_PutQueue(BufNum);
 break;
 case 'n':
 break;
 case 'o':
 break;
 case 'p':
 break;
 case 'q':
 break;
 case 'r':
 break;
 case 's':
 break;
 case 't':
 break;
 case 'u':
 break;
 case 'v':
 break;
 case 'w':
 break;
 case 'x':
 break;
 case 'y':
 break;
 case 'z':
 break;



 default:
 USB_PutQueue("Unknown command\r\n");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",readbuff[0]);
 USB_PutQueue(BufNum);
 break;
 }
 }
}
