/**************************************************************************************************
  USB_Driver.h
  This module is used for communications with the user through a custom PC program.
**************************************************************************************************/
#ifndef USB_DRIVER_H
#define USB_DRIVER_H

#define USB_Queue_Size 64        // Number of pointers in transmit FIFO


typedef char *pnt;

// Tx buffer FIFO and its input and output pointers
typedef struct USB_TxStruct {
     unsigned int in;        // Input pointer
     unsigned int out;       // Output pointer
     pnt q[USB_Queue_Size];  // Queue array of pointers
}USB_TxStruct;


// Function Prototypes
void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);

#endif